/*-
 * Copyright (c) 2003 Andrey Simonenko
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 *
 * THIS SOFTWARE IS PROVIDED BY THE AUTHOR AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE AUTHOR OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 *
 *   @(#)$Id: ipastat_log.h,v 1.1 2005/12/03 10:28:00 simon Exp $
 */

#ifndef IPASTAT_LOG_H
#define IPASTAT_LOG_H

extern const char *log_ident;

extern long	mypid;

extern void	open_close_log(void);

extern void	mvlogmsgx_wrapper(const char *, va_list);

extern void	(*xvlogmsgx)(int, const char *, va_list);

extern void	logmsg(int, const char *, ...) ATTR_FORMAT(printf, 2, 3);
extern void	logmsgx(int, const char *, ...) ATTR_FORMAT(printf, 2, 3);
extern void	vlogmsg(int, const char *, va_list) ATTR_FORMAT(printf, 2, 0);
extern void	xlogmsgx(int, const char *, ...) ATTR_FORMAT(printf, 2, 3);
extern void	vlogmsgx(int, const char *, va_list) ATTR_FORMAT(printf, 2, 0);

extern void	mod_logmsg(const char *, int, int, const char *, va_list);

#endif /* !IPASTAT_LOG_H */
